<?php

namespace Lozad;

use Lozad\Classes\Settings\SettingsConstants;

class FrontPageProcessing
{
    public static function start()
    {
        (new self())->handle();
    }

    private function handle()
    {
        add_action('wp_enqueue_scripts', [$this, 'includeLozadJs']);

        //add_filter('the_content', [$this, 'lozadContentProcessing']);
        add_filter('final_output', [$this, 'lozadContentProcessing']);
    }

    public function lozadContentProcessing($content)
    {
        return (new ContentProcessing($content))->handle();
    }

    public function includeLozadJs()
    {
        $pluginOptions = get_option(SettingsConstants::PAGE_SETTING_OPTION_NAME);

        $pluginDirUrl = plugin_dir_url(__DIR__);
        $includeInFooter = isset($pluginOptions[SettingsConstants::SETTING_WHERE_INCLUDE_SCRIPT])
            && $pluginOptions[SettingsConstants::SETTING_WHERE_INCLUDE_SCRIPT];

        wp_enqueue_script('jquery');
        wp_register_script('lozad_script', "{$pluginDirUrl}js/lozad.js", ['jquery'], false, $includeInFooter);
        wp_enqueue_script('lozad_script');
        wp_register_script('lozad_init_script', "{$pluginDirUrl}js/initLozad.js", ['jquery','lozad_script'], false, $includeInFooter);
        wp_enqueue_script('lozad_init_script');
    }
}